unit UFmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, Provider, DBClient, DBTables, StdCtrls, ExtCtrls, DBCtrls, Mask;

type
  TFmMain = class(TForm)
    QyProject: TQuery;
    DbMain: TDatabase;
    CdsProject: TClientDataSet;
    PvProject: TDataSetProvider;
    DsProject: TDataSource;
    CdsProjectPROJ_ID: TStringField;
    CdsProjectPROJ_NAME: TStringField;
    CdsProjectPROJ_DESC: TMemoField;
    CdsProjectTEAM_LEADER: TSmallintField;
    CdsProjectPRODUCT: TStringField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBMemo1: TDBMemo;
    Label4: TLabel;
    DBEdit3: TDBEdit;
    Label5: TLabel;
    DBEdit4: TDBEdit;
    DBNavigator1: TDBNavigator;
    PbDownload: TButton;
    PbUpload: TButton;
    procedure PbDownloadClick(Sender: TObject);
    procedure PbUploadClick(Sender: TObject);
    procedure CdsProjectReconcileError(DataSet: TClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FmMain: TFmMain;

implementation

{$R *.DFM}

uses
  RecError;

procedure TFmMain.PbDownloadClick(Sender: TObject);
begin
  with CdsProject do begin
    if Active then begin
      if ChangeCount = 0 then
        Refresh
      else if MessageDlg('Annullare le modifiche pendenti?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
        CancelUpdates;
        Refresh;
      end;
    end
    else
      Active := True;
  end;
  PbUpload.Enabled := True;
  DbMain.Close;
end;

procedure TFmMain.PbUploadClick(Sender: TObject);
var
  ErrorCount: Integer;
begin
  ErrorCount := CdsProject.ApplyUpdates(-1);
  if ErrorCount <> 0 then
    MessageDlg(Format('Sono stati rilevati degli errori; record non inviati: %d',
      [ErrorCount]), mtError, [mbOk], 0);
  DbMain.Close;
end;

procedure TFmMain.CdsProjectReconcileError(DataSet: TClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  Action := HandleReconcileError(DataSet, UpdateKind, E);
end;

end.
